package jcg.db;

import java.util.HashMap;
import java.util.Map;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.jdbc.support.rowset.SqlRowSet;

import com.mysql.jdbc.jdbc2.optional.MysqlDataSource;

public class NamedParameters {

	private MysqlDataSource dataSource;

	public static void main(String[] args) {

		ApplicationContext context = new ClassPathXmlApplicationContext("resources/spring-config.xml");
		NamedParameters np = (NamedParameters) context.getBean("NamedParameters");
		NamedParameterJdbcTemplate jdbcTemplate = new NamedParameterJdbcTemplate(np.getDataSource());
		String sql = "select * from jcg.engine where manufacturer = :manufacturer";
		Map<String, String> parameters = new HashMap<>();
		parameters.put("manufacturer", "ford");
		SqlRowSet rowSet = jdbcTemplate.queryForRowSet(sql, parameters);
		while (rowSet.next()) {
			System.out.println("RowNumber: " + rowSet.getRow());
			for (int i = 1; i < rowSet.getMetaData().getColumnCount(); i++) {
				System.out.println("ColumName: " + rowSet.getMetaData().getColumnName(i) + ", value: " + rowSet.getObject(i));
			}
			
		}
	}

	public MysqlDataSource getDataSource() {
		return dataSource;
	}

	public void setDataSource(MysqlDataSource dataSource) {
		this.dataSource = dataSource;
	}
}
